#define F_CPU 16000000UL
#include <avr/io.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <avr/eeprom.h>
#include <math.h> 	

int pulseLength=20;
int pulse_start;
char temp = 0;
/////////////////////////////////////////////////////////////////////////
ISR(INT0_vect){
//EIMSK=0;

//TCNT2= 0;
//while(TCNT2<16);
//if (PIND == 0){
emitPulse();
TCNT1=0;
while(TCNT1<2500);
EIFR=1<<INTF0;
//while(TCNT1<4000);
//EIMSK=1;
//}

}
/////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////
void emitPulse(){

TCNT2=0;
//pulse_start=TCNT2;
temp=1;
TCCR0A = (1<<COM0A0) | (0<<COM0A1) |(0<<COM0B0) | (1<<COM0B1)| (0<<WGM00) | (1<<WGM01) ;
//TCCR0B = 1;
while(TCNT2<pulseLength);
//while(TCNT2<(pulse_start+pulseLength));
//TCCR0B=0;
TCCR0A = (0<<COM0A0) | (0<<COM0A1) |(0<<COM0B0) | (1<<COM0B1)| (0<<WGM00) | (1<<WGM01) ;

}
////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
void init(){
//Set up PWM for pulse emition
DDRB = (1<<PINB3)|(1<<PINB4);
TCCR0B = 1 ;

TCCR0A = (0<<COM0A0) | (0<<COM0A1) |(0<<COM0B0) | (1<<COM0B1)| (0<<WGM00) | (1<<WGM01) ;

OCR0A = 199 ;	//40 kHz
//OCR0B = 100 ;

//Disable pulse
//TCCR0B=0;

//Setup timer for pulse
TCCR2B=6;

TCCR1B=3; //time to stop interrupt from being tripped by noise from tone decoder.

//Set up external int
//set up on pin D2, INT0
EIMSK=1;//Enable INT0
EICRA=2;//Set external int for falling edge detection
sei();//Needed for enabling INT

}
/////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
void main(){

init();


while(1);
/*{




TCNT1=0;
emitPulse();
while(TCNT1<30000){


//EIMSK=1;
}

}*/


}
/////////////////////////////////////////////////////////////////////////
