library verilog;
use verilog.vl_types.all;
entity AES_Decrypt is
    generic(
        key_expansion   : integer := 0;
        get_data        : integer := 1;
        init_add_round_key: integer := 2;
        wait_state      : integer := 3
    );
    port(
        data_set        : in     vl_logic;
        clock           : in     vl_logic;
        reset           : in     vl_logic;
        key             : in     vl_logic;
        decrypt_data    : out    vl_logic
    );
end AES_Decrypt;
