library verilog;
use verilog.vl_types.all;
entity Encryptor is
    generic(
        key_expansion   : integer := 0;
        get_data        : integer := 1;
        init_add_round_key: integer := 2;
        wait_state      : integer := 3;
        transfer        : integer := 4;
        next_word       : integer := 5
    );
    port(
        data_set        : in     vl_logic;
        clock           : in     vl_logic;
        reset           : in     vl_logic;
        key             : in     vl_logic;
        encrypt_data    : out    vl_logic
    );
end Encryptor;
